﻿using System;

namespace Obserwator
{
    using UMK.WzorceOperacyjne;

    class Program
    {
        static void Main(string[] args)
        {
            /*
            Podmiot podmiot = new Podmiot();

            IObserwator dzielenie = new Dzielenie(3);
            podmiot.PodłączObserwatora(dzielenie);

            podmiot.ZmieńWartość(9);
            Console.WriteLine();

            IObserwator modulo = new Modulo(3);
            podmiot.PodłączObserwatora(modulo);

            podmiot.ZmieńWartość(10);
            Console.WriteLine();

            podmiot.OdłączObserwatora(dzielenie);

            podmiot.ZmieńWartość(2);
            Console.WriteLine();
            */

            Podmiot podmiot = new Podmiot();
            podmiot.ZmienionaWartość += Podmiot_ZmienionaWartość;

            podmiot.ZmieńWartość(9);
            Console.WriteLine();

            podmiot.ZmienionaWartość +=
                (object? sender, Podmiot.ZmienionaWartośćEventArgs e) =>
                {
                    Console.WriteLine("{0} % {1} = {2}", e.NowaWartość, 3, e.NowaWartość % 3);
                };
            
            podmiot.ZmieńWartość(10);
            Console.WriteLine();

            podmiot.ZmienionaWartość -= Podmiot_ZmienionaWartość;

            podmiot.ZmieńWartość(2);
            Console.WriteLine();
        }

        private static void Podmiot_ZmienionaWartość(object? sender, Podmiot.ZmienionaWartośćEventArgs e)
        {
            Console.WriteLine("{0} / {1} = {2}", e.NowaWartość, 3, e.NowaWartość / 3);
        }
    }
}
